﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace UltraTreeMultiBands
{
    public partial class Form1 : Form
    {
        public static BindingList<MainClass> MyBList;
        public Form1()
        {
            InitializeComponent();
            ultraTree1.ViewStyle = Infragistics.Win.UltraWinTree.ViewStyle.FreeForm;
            ultraTree1.ExpandAll();

            MyBList = new BindingList<MainClass>();
            MyBList = MainClass.GetEmpList(10);
            ultraTree1.DataSource = MyBList;
        }

        private void ultraTree1_DoubleClick(object sender, EventArgs e)
        {
            ((MainClass)ultraTree1.ActiveNode.ListObject).ChildList.Add(MainClass.GetEmp());
            ultraTree1.ActiveNode.Expanded = true;
        }

        private void ultraTree1_AfterCellActivate(object sender, EventArgs e)
        {
            ultraTree1.ActiveCell.Appearance.BackColor = Color.Red;
        }

    }

    public class MainClass
    {

        public MainClass()
        {
            this.iD = 0;
            this.column1 = "Empty Item 1";
            this.column2 = "Empty Item 2";
        }

        public static int count;

        private int iD;
        public int ID
        {
            get { return iD; }
            set { iD = value; }
        }

        private string column1;
        public string Column1
        {
            get { return column1; }
            set { column1 = value; }
        }
        private string column2;
        public string Column2
        {
            get { return column2; }
            set { column2 = value; }
        }

        private BindingList<MainClass> childList;

        public BindingList<MainClass> ChildList
        {
            get { return childList; }
            set { childList = value; }
        }

        public static MainClass GetEmp()
        {
            MainClass emp = new MainClass();
            emp.ID = 100;
            emp.Column1 = "Item 100";
            emp.Column2 = "Item 100";
            emp.childList = new BindingList<MainClass>();
            return emp;
        }

        public static BindingList<MainClass> GetEmpList(int Num)
        {
            BindingList<MainClass> list = new BindingList<MainClass>();
            count++;
            for (int i = 0; i < Num; i++)
            {
                MainClass emp = new MainClass();
                emp.ID = i;
                emp.Column1 = "Item " + i.ToString();
                emp.Column2 = "Item " + i.ToString();
                emp.childList = new BindingList<MainClass>();
                if (count < 30) emp.childList = MainClass.GetEmpList(10);
                list.Add(emp);
            }
            return list;
        }
    }
}
